from g_align_nw import *

from time import *

import pylab as pl

#bucket_dim=50
bucket_dim=20
ratio=2.0/3.0
n0=0
step=4
nf=71
my_gap_penalty=-7

n=range(n0,nf,step)

tmax=[]
tmin=[]
tavg=[]

for x in n:
    timelist=[]
    for howmany in xrange(bucket_dim):
        s=make_rnd_DNA_seq(x)
        t=make_rnd_DNA_seq(x*ratio)
        t0=time()
        g_align_nw_simple(s, t, sim_m_0, my_gap_penalty)
        tf=time()
        timelist.append(tf-t0)
    tmax.append(max(timelist))
    tmin.append(min(timelist))
    tavg.append(float(sum(timelist))/len(timelist))


lmax,lmin,lavg = pl.plot(n,tmax,n,tmin,n,tavg)
pl.title('Runtime with ONE alignment')
pl.legend((lmax,lavg,lmin),("$t_{MAX}$","$t_{AVG}$","$t_{MIN}$"), 'upper left')
pl.show()

#second experiment (with all allignments)

n=range(n0,nf,step)

tmax=[]
tmin=[]
tavg=[]

for x in n:
    timelist=[]
    for howmany in xrange(bucket_dim):
        s=make_rnd_DNA_seq(x)
        t=make_rnd_DNA_seq(x*ratio)
        t0=time()
        g_align_nw(s, t, sim_m_0, my_gap_penalty)
        tf=time()
        timelist.append(tf-t0)
    tmax.append(max(timelist))
    tmin.append(min(timelist))
    tavg.append(float(sum(timelist))/len(timelist))


lmax,lmin,lavg = pl.plot(n,tmax,n,tmin,n,tavg)
pl.title('Runtime with all alignments')
pl.legend((lmax,lavg,lmin),("$t_{MAX}$","$t_{AVG}$","$t_{MIN}$"), 'upper left')
pl.show()

#third experiment (with all allignments)

n=range(n0,nf,step)

nummax=[]
nummin=[]
numavg=[]

for x in n:
    numlist=[]
    for howmany in xrange(bucket_dim):
        s=make_rnd_DNA_seq(x)
        t=make_rnd_DNA_seq(x*ratio)
        h=g_align_nw(s, t, sim_m_0, my_gap_penalty)
        
        numlist.append(len(h))
    nummax.append(max(numlist))
    nummin.append(min(numlist))
    numavg.append(float(sum(numlist))/len(numlist))


lmax= pl.plot(n,nummax)
pl.title('Number of alignments')
#pl.legend((lmax,lavg,lmin),("$N_{MAX}$","$N_{AVG}$","$N_{MIN}$"), 'upper left')
pl.show()

